// PLANE_MASTERs are fairly basic.
// Anything sharing a plane value as a PLANE_MASTER will be drawn as a group with that PLANE_MASTER
// This makes things like screen effects and color manipulation possible without having to mass-modify objects.
// You simply have to manipulate the PLANE_MASTER and anything on that plane will be manipulated right along with it.

obj
	planes
		master
			plane = MASTER_PLANE
			appearance_flags = PLANE_MASTER
			screen_loc = "CENTER"
			// To create a PLANE_MASTER all you need to do is set this appearance_flag.
			// I've also set NO_CLIENT_COLOR so that the planes won't be effected by client.color
			// Doing this on plane 0 as we are here actually makes client.color affect nothing but things on other planes (which we won't have)


		darkness
			plane = DARKNESS_PLANE
			blend_mode = BLEND_MULTIPLY
			appearance_flags = PLANE_MASTER | NO_CLIENT_COLOR
			color = list(1,0,0,0, 0,1,0,0, 0,0,1,0, 0,0,0,0, 0.1,0.1,0.1,1)
			mouse_opacity = 0
			screen_loc = "CENTER"
			New()
				..()
				vis_contents += new/obj/backdrop

			// Now for the darkness, we set atom.color to a pure black with about 10% alpha
			// And mouse_opacity has 0 so your lights and darkness don't capture mouse events.
			// We're also adding a pure black backdrop to the player's screen using this plane and the backdrop object.
			// We set blend_mode to BLEND_MULTIPLY here because we want it to multiply the color of anything behind it.
			// Which means most everything behind it (on plane 0, the default) is going to blend darker.
			// This way when you add the BLEND_ADD of the lights on the same plane you start pushing backwards towards the base coloring.
			// This accomplishes a darkness/lighting effect nicely.


